#include "FlashConfig.h"
#include "FlashOS.h"

struct FlashDevice const FlashDevice = {
    FLASH_DRV_VERS,                  // Driver Version, do not modify!
    "PY32_PROGRAM",                  // Device Name
    ONCHIP,                          // Device Type
    APP_FLASH_BASE,                  // Device Start Address
    APP_FLASH_SIZE,                  // Device Size in Bytes (64MB)
    APP_FLASH_PAGE_SIZE,             // Programming Page Size 512 Bytes (256 bytes per page * 2)
    0x00,                            // Reserved, must be 0
    0xFF,                            // Initial Content of Erased Memory
    APP_FLASH_PAGE_PROGRAM_TIMEOUT,  // Program Page Timeout 100 mSec
    APP_FLASH_SECTOR_ERASE_TIMEOUT,  // Erase Sector Timeout 6000 mSec

    /* clang-format off */
    // Specify Size and Address of Sectors
    {
    {APP_FLASH_SECTOR_SIZE, 0x000000,},  // Uniform sector/page layout
    {SECTOR_END,},
    },
    /* clang-format on */
};
